(function ($, window) {

	const FIRST = 3;
	const LAST = 890;
	var a;
	var c;
	var renderTimer;
	var analyser;
	var f;

	window.vis = {

		init: function (audio, canvas) {

			// Apparently firefox does not support the visualization with streaming sources. Sounds just keeps cutting out.
			if (navigator.userAgent.toLowerCase().indexOf('firefox') > -1) {
				$(canvas).remove();
				return;
			}

			a = audio;
			c = canvas;

			a.addEventListener('playing', vis.playing);
			a.addEventListener('stopeed', vis.stopped);

			window.AudioContext = window.AudioContext || window.webkitAudioContext || window.mozAudioContext

			var ctx = new AudioContext();
			analyser = ctx.createAnalyser();

			var audioSrc = ctx.createMediaElementSource(a);
			audioSrc.connect(analyser);
			f = new Uint8Array(analyser.frequencyBinCount);
			analyser.connect(ctx.destination);

		},

		playing: function () {
			vis.stopped();
			renderTimer = setInterval(vis.render, 1000 / 60);
		},
		stopped: function () {
			if (renderTimer)
				clearInterval(renderTimer);
		},
		render: function () {
			var d = c.getContext('2d');

			d.clearRect(0, 0, c.width, c.height);

			analyser.getByteFrequencyData(f);

			var path = new Path2D();

			var w = c.width;
			var h = c.height;


			for (var i = FIRST; i < LAST; i++) {
				var y = h - (f[i] / 255.0 * h);
				var x = (i - FIRST) / LAST * w;

				if (i == FIRST)
					path.moveTo(x, y);
				else
					path.lineTo(x, y);
			}
			d.strokeStyle = 'white';
			d.stroke(path);
		}
	};

})($, window);